﻿// ECMAScript 5 strict mode
"use strict";


assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");



/// Plugin class
cr.plugins_.Jsob = function( runtime )
{
	this.runtime = runtime;
};




(function ()
{
	//.	"static-Java-style" storage var
	var memorizedQKeyPars_btb = null;

	var pluginProto = cr.plugins_.Jsob.prototype;
		
	//	//\\	Plugin-based cache. 		/////////////////////////////////////
	//			Assumed, the only one instance of plugin will exist in c2.
	var pCache = {};
	//	\\//	Plugin-based cache. 		/////////////////////////////////////







	//	//\\	Object type class		/////////////////////////////////////
	pluginProto.Type = function( plugin )
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	
	var typeProto = pluginProto.Type.prototype;

	typeProto.onCreate = function()
	{
	};
	//	\\//	Object type class		/////////////////////////////////////






	//	//\\	Instance class		/////////////////////////////////////
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		// any other properties you need, e.g...
		// this.myValue = 0;
	};
	
	var instanceProto = pluginProto.Instance.prototype;

	instanceProto.onCreate = function()
	{
		this.jsob = {};
		this.curName = '';
		this.curValue = '';
		// note the object is sealed after this call; ensure any properties you'll ever need are set on the object
		// e.g...
		// this.myValue = 0;
	};
	
	// called whenever an instance is destroyed
	// note the runtime may keep the object after this call for recycling; be sure
	// to release/recycle/reset any references to other objects in this function.
	instanceProto.onDestroy = function ()
	{
	};

	/*
	//	TODM not sure do we need this?:
	instanceProto.getAsJSON = function ()
	{
		return JSON.stringify( this.jsob );
	};
	*/

	
	// called when saving the full state of the game
	instanceProto.saveToJSON = function ()
	{

		// return a Javascript object containing information about your object's state
		// note you MUST use double-quote syntax (e.g. "property": value) to prevent
		// Closure Compiler renaming and breaking the save format
		return {
			// e.g.
			//"myValue": this.myValue
		};
	};


	
	// called when loading the full state of the game
	instanceProto.loadFromJSON = function (o)


	{
		// load from the state previously saved by saveToJSON
		// 'o' provides the same object that you saved, e.g.
		// this.myValue = o["myValue"];
		// note you MUST use double-quote syntax (e.g. o["property"]) to prevent
		// Closure Compiler renaming and breaking the save format
	};
	
	// only called if a layout object - draw to a canvas 2D context
	instanceProto.draw = function(ctx)
	{
	};
	
	// only called if a layout object in WebGL mode - draw to the WebGL context
	// 'glw' is not a WebGL context, it's a wrapper - you can find its methods in GLWrap.js in the install
	// directory or just copy what other plugins do.
	instanceProto.drawGL = function (glw)
	{
	};
	
	// The comments around these functions ensure they are removed when exporting, since the
	// debugger code is no longer relevant after publishing.
	/**BEGIN-PREVIEWONLY**/
	instanceProto.getDebuggerValues = function (propsections)
	{
		// Append to propsections any debugger sections you want to appear.
		// Each section is an object with two members: "title" and "properties".
		// "properties" is an array of individual debugger properties to display
		// with their name and value, and some other optional settings.
		propsections.push({
			"title": "My debugger section",
			"properties": [
				// Each property entry can use the following values:
				// "name" (required): name of the property (must be unique within this section)
				// "value" (required): a boolean, number or string for the value
				// "html" (optional, default false): set to true to interpret the name and value
				//									 as HTML strings rather than simple plain text
				// "readonly" (optional, default false): set to true to disable editing the property
				
				// Example:
				// {"name": "My property", "value": this.myValue}
			]
		});
	};
	
	instanceProto.onDebugValueEdited = function (header, name, value)
	{
		// Called when a non-readonly property has been edited in the debugger. Usually you only
		// will need 'name' (the property name) and 'value', but you can also use 'header' (the
		// header title for the section) to distinguish properties with the same name.
		if (name === "My property")
			this.myProperty = value;
	};
	/**END-PREVIEWONLY**/
	//	\\//	Instance class		/////////////////////////////////////




	//	//\\	Conditions and instance-meth.			/////////////////////////////////////
	function Cnds() {};

	///	TODM not sure do we need this?
	// the example condition
	Cnds.prototype.MyCondition = function (myparam)
	{

		// return true if number is positive
		return myparam >= 0;
	};



	instanceProto.doForEachTrigger = function (current_event)
	{
		this.runtime.pushCopySol( current_event.solModifiers );
		current_event.retrigger ();
		this.runtime.popSol( current_event.solModifiers );
	};
	
	Cnds.prototype.forEach = function ()
	{
        var current_event = this.runtime.getCurrentEventStack().current_event;

		var hasOwn	= Object.prototype.hasOwnProperty;
		var ob		= this.jsob;
		for( var pp in ob )
		{
			if( hasOwn.call( ob, pp ) ) // if( ob.hasOwnProperty( p ) )
			{
				this.curName = pp;
				this.curValue = ob[ pp ];
				this.doForEachTrigger( current_event );
			}
		}
		return false;	// TODO why?
	};
	






	pluginProto.cnds = new Cnds();
	//	\\//	Conditions			/////////////////////////////////////




	
	// //\\		Actions		//////////////////////////////////////
	function Acts() {};

	/*
	Acts.prototype.evaluateCommand = function ( command )
	{
		eval( command );
	};
	*/

	Acts.prototype.set = function ( path, value )
	{
		//	this.jsob[ path ] = value;
		set( this.jsob, path, value );
	};
	
	Acts.prototype.json2ob = function ( json )
	{
		try {
			this.jsob = JSON.parse( json );
			//	c onsole.log( 'this.jsob = ', this.jsob );
		}
		catch(e) {

			/// it is better to add error property, than empty object
			//	there is a little chance this property will collide with application;
			this.jsob =
			{	"error of parsing JSON :::: " :
				e + "\n" +
				"************** here is a troubled JSON = \n" +
				json +
				"************** end of troubled JSON = \n"
			};
			//	good: c onsole.log( 'error = ' + e );
			return;
		}
	};

	Acts.prototype.json2path = function ( path, json )
	{
		try {
			var ww = get( JSON.parse( json ), path );
			//.	"stealthy leaves"
			if( typeof ww !== 'object' || ww === null ) return;
			this.jsob = ww;
		}
		catch(e)
		{
			//	c onsole.log( "error" + e );
			return;
		}
	};



	//	//\\	Instance-independent methods. "Static". Do work on cache.
	//			ABANDONED. NO TIME TO MAKE HAPPEN.
	Acts.prototype.json2cache = function ( name, json )
	{
		try {
			var obj = JSON.parse( json );
			//	c onsole.log( 'this.jsob = ', this.jsob );
		}
		catch(e) {
			//	good: c onsole.log( 'error = ' + e );
			return;
		}
		pCache[ name ] = obj;
	}

	Acts.prototype.deleteFromCache = function ( name )
	{
		delete pCache[ name ];
	}

	Acts.prototype.assign = function ( destinationName, destinationPath, departureName, departurePath )
	{
		try {
			var des = pCache[ destinationName ];
			var dep = pCache[ departureName ];
			set( des, destinationPath, get( dep, departurePath ) );
			//	c onsole.log( 'this.jsob = ', this.jsob );
		}
		catch(e) {
			//	good: c onsole.log( 'error = ' + e );
			return;
		}
	}
	//	\\//	Instance-independent methods. "Static". Do work on cache.

	pluginProto.acts = new Acts();
	// \\//		Actions		//////////////////////////////////////






	//	//\\	Expressions		//////////////////////////////////////
	function Exps() {};

	Exps.prototype.get = function ( ret, path )
	{
		var val = get( this.jsob, path );
		var type = typeof val;
		if( type === 'string' )
		{
			ret.set_string( val );
		} else if( type === 'number' ) {
			ret.set_any( val );
		} else {
			///	falls back to empty string
			ret.set_string( '' );	
		}
	};
	
	///	redundant TODM "rid"
	Exps.prototype.ob2json = function ( ret )
	{
		var ww = JSON.stringify( this.jsob, null, "\t" );
		ret.set_string( ww );
	};

	Exps.prototype.path2json = function ( ret, path )
	{
		var ww = get( this.jsob, path );
		var ww = JSON.stringify( ww, null, "\t" );
		ret.set_string( ww );
	};


	Exps.prototype.CurName = function ( ret )
	{
		ret.set_string( this.curName );
	};

	Exps.prototype.CurValue = function ( ret )
	{
		var val		= this.curValue;
		var type	= typeof val;
		if( type === 'string' )
		{
			ret.set_string( val );
		} else if( type === 'number' ) {
			ret.set_any( val );
		} else {
			///	falls back to empty string
			ret.set_string( '' );	
		}
	};

	
	Exps.prototype.get_url_key_value = function ( ret, path )
	{
		var ww = getQueryKeyPairs_btb( !'integrify' );
		var val = get( ww, path );
		var type = typeof val;
		if( type === 'string' )
		{
			ret.set_string( val );
		} else if( type === 'number' ) {
			ret.set_any( val );
		} else {
			///	falls back to empty string
			ret.set_string( '' );	
		}
	};


	pluginProto.exps = new Exps();
	//	\\//	Expressions		//////////////////////////////////////






	//\\//	Own microlibrary


	/// Acts:		extends object's property-tree and assigns value to a leaf-property
	//
	//	Usage:		propertify( conf, 'startup.items', 4 ) assigns
	//				conf.startup.items = value "starup" initially does not exist.
	//
	//	Input:		obj - top object, as in above obj = conf;
	//				No '.' is allowed in tokens and in a value.
	var set = function ( obj, path, value )
	{
		var tokens	= path.split( '.' );
		var len		= tokens.length;
		var len1	= len - 1;
		if( len1 < 0 ) return;
		var prop	= tokens[ 0 ];

		for( var ii = 0; ii < len1; ii++ )
		{
			//// appends objects if missed
			if( !obj[ prop ] || typeof obj[ prop ] !== 'object' ) obj[ prop ] = {};
			obj = obj[ prop ];
			var prop = tokens[ ii + 1 ];
		}
		obj[ prop ] = value;
	};


	///	returns value from obj[ path ]" even path is like path = level.child3.node2. ...
	var get = function ( obj, path )
	{
		if( !path ) return obj;
		var tokens	= path.split( '.' );
		var len		= tokens.length;
		var len1	= len - 1;
		if( len1 < 0 ) return;
		var prop	= tokens[ 0 ];

		for( var ii = 0; ii < len1; ii++ )
		{
			obj = obj[ prop ];
			if( typeof obj === 'undefined' ) return obj;
			var prop = tokens[ ii + 1 ];
		}
		// if( prop === 'length' ) console.log( obj, ' length=' + obj[ prop ] );
		return obj[ prop ];
	};






	///	Converts:	URL-query string [?]key1=val1&key2~val2 .... to
	//				{ ... key : vala, .... } object.
	//				"~" does flag float value.
	//				keys without "=value" assigned value JS-constant true
	//	Algorithm:	reuses memorizedQKeyPars_btb
	//
	//	Input:		integerify - optional; if given, integerifies all numeric parameters.
	//	Output:		memorizes result in memorizedQKeyPars_btb.
	//	Returns:	{} if nothing detected
	//	Alternatives:	http://stackoverflow.com/questions/901115/how-can-i-get-query-string-values-in-javascript
	var getQueryKeyPairs_btb = function( integerify )
	{
		if( memorizedQKeyPars_btb ) return memorizedQKeyPars_btb;
		//. Parenthesises are because gedit does not like "* /"
		var ww = window.location.search.replace( /^(\s*)/, '' );
		if( ww.charAt(0) === '?' )
		{
			ww = ww.substr(1);
		}
		if( !ww || ww.length === 0 )
		{
			memorizedQKeyPars_btb = {};
			return memorizedQKeyPars_btb;
		}
		var splitted = ww.split( '&' );
		var pairs = {};
		for( var ii = 0; ii < splitted.length; ii++ )
		{
			var token = splitted[ ii ];
			if( token === '' ) continue;
			var pair = token.split( '=' );
			var numerify = integerify ? 'i' : '';
			if( pair.length === 1 )
			{
				var pair = token.split( '~' );
				if( pair.length === 1 )
				{
					pairs[ token ] = true;
					continue;
				}else{
					//.	Normalizes for propertifier
					token = token.replace( '~', '=' );
					var numerify = 'f';
				}
			}
			propertify( pairs, token, !'convert_URI_Value', numerify );
			//pairs[ pair[ 0 ] ] = value;
		}
		memorizedQKeyPars_btb = pairs;
		return pairs;
	};



	/// Acts:		extends object's property-tree and assigns value to a leaf-property
	//	Usage:		propertify( conf, 'startup.items=4' ) assigns
	//				conf.startup.items = "4" even "starup" initially does not exist.
	//	Input:		obj - top object
	//				No '.' and '=' is allowed in tokens and in a value.
	//				converter - opt. Is a function to convert: see: (*).
	//				numerify - opt. Parameter for converter
	var propertify = function ( obj, string, converter, numerify )
	{
		if( !obj || typeof obj !== 'object' ) return;
		var parts	= string.split( '=' );
		if( parts.length < 2 ) return;
		var value	= parts[1];
		var tokens	= parts[0].split( '.' );
		var len		= tokens.length;
		var len1	= len - 1;
		if( len1 < 0 ) return;
		var prop	= tokens[ 0 ];

		for( var ii = 0; ii < len1; ii++ )
		{
			//:: appends objects if missed
			if( !obj[ prop ] || typeof obj[ prop ] !== 'object' ) obj[ prop ] = {};
			obj = obj[ prop ];
			var prop = tokens[ ii + 1 ];
		}
		obj[ prop ] = converter ? converter( value, numerify ) : value;	// (*)
	};



}());